<template>
  <div>
    <modal v-if="modal" title="Новая организация" @close="changeModalState">
      <organization @close="changeModalState"/>
    </modal>
    <div class="wp-title wp-12">Организации</div>
    <nav-bar v-model="search" @action="changeModalState"/>
    <masonry class="wp-12"
      :columnClass="MasonryColumnClass"
      :cols="MasonryColumns"
      :gutter="MasonryGutter">
      <card v-for="(organization, index) in filteredOrganizations" :key="index"
        :title="organization.name"
        delete @delete="removeOrganization(organization.id)">
        <div class="wp-layout">
          <div class="wp-12 wp-field">
            <div class="wp-field__title">
              Название
            </div>
            <div class="wp-field__content">
              <div class="wp-field__text wp-12">
                {{ organization.name }}
              </div>
              <div v-if="selectedOrganization !== organization.id"
                class="wp-field__button wp-field__button--side"
                @click="selectOrganization(organization.id)">
                <font-awesome-icon icon="check" size="lg"/>
              </div>
            </div>
          </div>
        </div>
      </card>
    </masonry>
  </div>
</template>

<script>
import { mapState, mapActions } from 'vuex';

import { MasonryGutter, MasonryColumnClass, MasonryColumns } from '@/shared';

import Card from '@/components/Card.vue';
import NavBar from '@/components/NavBar.vue';

import Modal from '@/components/modal/Modal.vue';
import Organization from '@/components/modal/admin/organizations/Organization.vue';

export default {
  name: 'Organizations',
  components: {
    NavBar,
    Card,
    Modal,
    Organization,
  },
  data() {
    return {
      MasonryGutter,
      MasonryColumns,
      MasonryColumnClass,
      modal: false,
      search: '',
    };
  },
  computed: {
    ...mapState('admin', ['organizations']),
    ...mapState('session', ['selectedOrganization']),
    filteredOrganizations() {
      return this.organizations.filter(organization => organization.name.toLowerCase().indexOf(
        this.search.toLowerCase(),
      ) !== -1);
    },
  },
  methods: {
    ...mapActions('admin', [
      'getOrganizations',
      'deleteOrganization',
    ]),
    ...mapActions('session', ['selectOrganization']),
    changeModalState() {
      this.modal = !this.modal;
    },
    async removeOrganization(organizationID) {
      try {
        await this.deleteOrganization(organizationID);
        this.$toasted.success('Организация удалена');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
  },
  created() {
    this.getOrganizations();
  },
};
</script>

<style lang="scss" scoped>
</style>
